Bullet = class("Bullet", Obj)

BulletR = 2
BulletPower = 10
BULLET_SPEED = 2

BT_LINE = 1
BT_MISSILE = 3

MISSILE_FUEL = 200

function Bullet:initialize(bulletType, colorType, x, y, angle, targetPower)
	Obj.initialize(self, Graphics.white_bullet, BulletR)
	
	self.bulletType = bulletType
	self.colorType = colorType
	self._x = x
	self._y = y
	self.angle = angle
	self.sx = BULLET_SPEED * math.cos(angle)
	self.sy = BULLET_SPEED * math.sin(angle)
	self.power = BulletPower
	self.targetPower = targetPower
	
	if self.bulletType == BT_MISSILE then
		self.fuel = MISSILE_FUEL
	end
	
	if colorType == CT_ORANGE then
	    table.insert(OrangeBullets, self)
	elseif colorType == CT_BLUE then
    	table.insert(BlueBullets, self)
	else
		error("Unknow colorType: " .. colorType)
	end
	
	if self._y > 0 then
		PlayWeaponFireSfx()
	end
	
	self.validTop = 0
	
	self:updateBox()
end

MISSILE_ROTATE_SPEED = math.pi / 100

function Bullet:update()
	if self.bulletType == BT_MISSILE then
		if self.targetPower.dead == false and self.fuel > 0 then
			self.fuel = self.fuel - 1
			
			local newAngle = math.atan2(self.targetPower._y - self._y, self.targetPower._x - self._x)
			if math.abs(newAngle - self.angle) > math.pi then
				if newAngle > self.angle then
					newAngle = newAngle - math.pi * 2
				elseif newAngle < self.angle then
					newAngle = newAngle + math.pi * 2
				end
			end
			
			local dAngle = newAngle - self.angle
			if dAngle > MISSILE_ROTATE_SPEED then
				dAngle = MISSILE_ROTATE_SPEED
			elseif dAngle < -MISSILE_ROTATE_SPEED then
				dAngle = -MISSILE_ROTATE_SPEED
			end

			self.angle = self.angle + dAngle
			
			if self.angle > math.pi then
				self.angle = self.angle - math.pi * 2
			elseif self.angle < -math.pi then
				self.angle = self.angle + math.pi * 2
			end
			
			if self.angle > math.pi * 2 then
			error("too large")
			end
			self.sx = BULLET_SPEED * math.cos(self.angle)
			self.sy = BULLET_SPEED * math.sin(self.angle)
		end
	end
	
	self._x = self._x + self.sx
	self._y = self._y + self.sy
	self:updateBox()
end

function Bullet:testHit(targetTowers)
	for i, tower in ipairs(targetTowers) do
		if tower.dead == false then
			if tower:collideWith(self) then
				tower:reducePower(self.power)
				if tower.dead == true then
					AddTowerExplode(tower._x, tower._y)
				end
				self:reducePower(self.power)
				return true
			end
		end
	end
	
	return false
end

