Defender = class("Defender", PowerSource)

DEFENDER_DELAY = 100

function Defender:initialize()
	PowerSource.initialize(self, TOWER_POWER, CT_BLUE)
	self.delay = DEFENDER_DELAY
end

BLUE_TOWER_Y_SPEED = 0.5

BLUE_TOWER_MAX_YPOS = 150
BLUE_TOWER_MIN_XPOS = 40
BLUE_TOWER_MAX_XPOS = GameWidth - 40
BLUE_TOWER_X_SPEED = 0.5

BLUE_TOWER_ATTRACT_MAX_Y = GameHeight / 3
BLUE_TOWER_ATTRACT_SPEED = 2
BLUE_TOWER_ATTRACT_SPEED2 = 0.3

function Defender:update()
	if self.delay > 0 then
		self.delay = self.delay - 1
	else
	    if self._y < BLUE_TOWER_MAX_YPOS then
			if self._y < GENERATE_BOX_BOTTOM then
				self:move(0, BLUE_TOWER_Y_SPEED * 10)
			else
				self:move(0, BLUE_TOWER_Y_SPEED)
			end
		else
			if self.moveLeft == nil then
				self.moveLeft = false
				if math.random() > 0.5 then
					self.moveLeft = true
				end
			end

			if self.moveLeft == true then
				self:move(-BLUE_TOWER_X_SPEED, 0)
				if self._x <= BLUE_TOWER_MIN_XPOS then
					self.moveLeft = false
				end
			else
				self:move(BLUE_TOWER_X_SPEED, 0)
				if self._x >= BLUE_TOWER_MAX_XPOS then
					self.moveLeft = true
				end
			end
		end
	end
	
	PowerSource.update(self)
end

function Defender:tryAttractTower(tower)
	if tower.colorType ~= CT_WHITE then
		error("Defender can only attract WhiteTowers!")
	end
	
	if tower._y < GENERATE_BOX_BOTTOM then
		local dx, dy = getStep(self._x - tower._x, self._y - tower._y, BLUE_TOWER_ATTRACT_SPEED)
		tower:move(dx, dy)
	elseif tower._y < BLUE_TOWER_ATTRACT_MAX_Y then
		local dx, dy = getStep(self._x - tower._x, self._y - tower._y, BLUE_TOWER_ATTRACT_SPEED2)
		tower:move(dx, dy)
	end
end

