local  FinishScreen = Game:addState("FinishScreen")

function FinishScreen:enterState()
	self.Defenders = {}
	
	for j=-8, GameHeight, 30 do
		for i=-8, GameWidth, 30 do
			local defender = Defender:new()
			defender:setPos(i + 10, j + 10)
			table.insert(self.Defenders, defender)
		end
	end
	
	self.tickCount = 0
	self.tickScale = 1
end

local TICKS_TO_EXPLODE_ONE_DEFENDER = 10

function FinishScreen:update()

	self.tickCount = self.tickCount + 1
	local scale = (260 - self.tickScale) / 260  * (260 - self.tickScale) / 260
	if self.tickCount >= TICKS_TO_EXPLODE_ONE_DEFENDER * scale then
		if #self.Defenders > 0 then
			local tower = table.remove(self.Defenders, #self.Defenders)
			AddTowerExplode(tower._x, tower._y)
		end
		self.tickCount = 0
		self.tickScale = self.tickScale + 1
	end

	UpdateParticles()

	if #Particles == 0 then
		if #self.Defenders == 0 then
			Game:popState()
			Game:pushState("WinScreen")
		end
	end
end

function FinishScreen:draw()
	love.graphics.draw(Graphics.backgrnd,0,0,0,1,1)

	love.graphics.setColor(Color.blue)
	self:drawObjs(self.Defenders)

	DrawParticles()

	love.graphics.setColor(Color.default)
end

function FinishScreen:drawObjs(objs)
	for i, obj in ipairs(objs) do
		local x, y = obj:getPos()
		obj:setPos(x + (math.random() - 0.5) * self.tickScale / 260 * 10, y + (math.random() - 0.5) * self.tickScale / 260 * 10)
		obj:draw()
		obj:setPos(x, y)
	end
end

function FinishScreen:exitState()
end


