Obj = class("Obj")

function Obj:initialize(image, r)
	self.image = image
	self.ox = self.image:getWidth() / 2
	self.oy = self.image:getHeight() / 2	
	self.r = r
	
	self.power = 100
	self.originalPower = 100
	self.dead = false
	
	self._x = GameWidth / 2
	self._y = GameHeight / 2
	
	self.followers = {}
	
	self.validTop = 0 - GameHeight / 2
	self.validBottom = GameHeight + 20
	self.validLeft = 0 - GameWidth / 2
	self.validRight = GameWidth + GameWidth / 2

--[[
	self.validTop = 5
	self.validBottom = GameHeight -5
	self.validLeft = 5
	self.validRight = GameWidth -5
]]
	
	self:updateBox()
end

function Obj:update()
	for i, obj in ipairs(self.followers) do
		obj:update()
	end
end

function Obj:draw()
	if self.dead == false then
		love.graphics.draw(
			self.image,
			self._x, self._y,
			0,
			1, 1,
			self.ox, self.oy)
	end
	
	for i, obj in ipairs(self.followers) do
		obj:draw()
	end
end

function Obj:updateBox()
	self.top = self._y - self.r
	self.bottom = self._y + self.r
	self.left = self._x - self.r
	self.right = self._x + self.r
end

function Obj:getX()
	return self._x
end

function Obj:getY()
	return self._y
end

function Obj:getPos()
	return self._x, self._y
end

function Obj:setX(x)
	self._x = x
	self:updateBox()
end

function Obj:setY(y)
	self._y = y
	self:updateBox()
end

function Obj:setPos(x, y)
	self._x = x
	self._y = y
	self:updateBox();
end

function Obj:move(dx, dy)
	self._x = self._x + dx
	self._y = self._y + dy
	
	for i, obj in ipairs(self.followers) do
		obj:move(dx, dy)
	end
	
	self:updateBox()
end

function Obj:reducePower(dpower)
	self:setPower(self.power - dpower)
end

function Obj:setPower(power)
	self.power = power
	if self.power <= 0 then
		self.dead = true
	end
	self:_updateImageByPower()
end

function Obj:_updateImageByPower()
end

function Obj:outOfScreen()
	if self._y > self.validBottom then
		return true
	elseif self._y < self.validTop then
		return true
	elseif self._x < self.validLeft then
		return true
	elseif self._x > self.validRight then
		return true
	else
		return false
	end
end

function Obj:shouldBeDelete()
	return self.dead or self:outOfScreen()
end

function Obj:collectAll(objArray)
	for i, obj in ipairs(self.followers) do
		obj:collectAll(objArray)
		table.insert(objArray, obj)
	end
end

function Obj:collideWith(otherObj)
	if self.bottom < otherObj.top then
		return false
	elseif self.top > otherObj.bottom then
		return false
	elseif self.right < otherObj.left then
		return false
	elseif self.left > otherObj.right then
		return false
	end
	
	local dist = distanceFrom(self._x, self._y, otherObj._x, otherObj._y)
	return dist <= self.r + otherObj.r
end

function Obj:addFollower(follower)
	table.insert(self.followers, follower)
end

