PlayerClass = class("PlayerClass", PowerSource)

function PlayerClass:initialize()
	PowerSource.initialize(self, TOWER_POWER, CT_ORANGE)
end

PLAYER_SPEED = 5

function PlayerClass:moveByInput()
	local px, py = Player:getPos()
	
	local tx, ty = px, py

	-- controlled by arrow keys
	if love.keyboard.isDown("left") then
		tx = tx - PLAYER_SPEED
	end
	if love.keyboard.isDown("right") then
		tx = tx + PLAYER_SPEED
	end
	if love.keyboard.isDown("up") then
		ty = ty - PLAYER_SPEED
	end
	if love.keyboard.isDown("down") then
		ty = ty + PLAYER_SPEED
	end

	-- controlled by mouse when left mouse button is down
	if love.mouse.isDown("l") then
		tx, ty = love.mouse.getPosition()
	end

	-- make sure the target point is in the game screen
	tx, ty = makeValid(tx, ty)

	-- Todo: maybe the speed could be modified by the player's weight, i.e. tower's count
	local dx, dy = getStep(tx - px, ty - py, PLAYER_SPEED)

	Player:move(dx, dy)
end


